<%
class ItemMenu
    private M_Name
    private M_Style
    private M_Top
    private M_Left
    private M_AlwaysVisible
    private M_Orientation
    private M_Margin
    private M_OverFlow
    private M_ImgPath
    private M_AI()
    
    private sub Class_Initialize()
        redim M_AI(0)
    end sub
    private sub Class_Terminate()
    end sub
    
    Public Property Get AI(byval Index)
        if Index >= 1 and Index <= Ubound(M_AI) then
            set AI = M_AI(Index)
        elseif Index = NextAI then
            redim preserve M_AI(Index)
            set M_AI(Index) = new cls_AI
            M_AI(Index).ImgPath = M_ImgPath
            set AI = M_AI(Index)
        end if
    End Property
    
    public Property Get NextAI
        NextAI = UBound(M_AI) + 1
    end property

    Public Property Let ImgPath(ByVal value)
        M_ImgPath = value
    end Property

    Public Property Let Style(ByVal value)
        M_Style = value
    end Property
    Public Property Get Style()
        Style = M_Style
    End Property

    Public Property Let Name(ByVal value)
        M_Name = value
    end Property
    Public Property Get Name()
        Name = M_Name
    End Property

    Public Property Let Top(ByVal value)
        M_Top = value
    end Property
    Public Property Get Top()
        Top = M_Top
    End Property

    Public Property Let Left(ByVal value)
        M_Left = value
    end Property
    Public Property Get Left()
        Left = M_Left
    End Property

    Public Property Let AlwaysVisible(ByVal value)
        M_AlwaysVisible = value
    end Property
    Public Property Get AlwaysVisible()
        AlwaysVisible = M_AlwaysVisible
    End Property

    Public Property Let Orientation(ByVal value)
        M_Orientation = value
    end Property
    Public Property Get Orientation()
        Orientation = M_Orientation
    End Property

    Public Property Let Margin(ByVal value)
        M_Margin = value
    end Property
    Public Property Get Margin()
        Margin = M_Margin
    End Property

    Public Property Let OverFlow(ByVal value)
        M_OverFlow = value
    end Property
    Public Property Get OverFlow()
        OverFlow = M_OverFlow
    End Property

    Public Property Get NumAI()
        NumAI = UBound(M_AI)
    end Property
end class

class cls_AI
    private M_Text
    private M_Url
    private M_Status
    private M_ShowMenu
    private M_Image
    private M_ImgPath
    
    private sub Class_Initialize()
        M_Text = ""
        M_Url = ""
        M_Status = ""
        M_ShowMenu = ""
        M_Image = ""
        M_ImgPath = ""
    end sub

    Public Property Let Text(ByVal value)
        M_Text = value
    end Property
    Public Property Get Text()
        Text = M_Text
    End Property

    Public Property Let Url(ByVal value)
        M_Url = value
    end Property
    Public Property Get Url()
        Url = M_Url
    End Property

    Public Property Let Status(ByVal value)
        M_Status = value
    end Property
    Public Property Get Status()
        Status = M_Status
    End Property

    Public Property Let ShowMenu(ByVal value)
        M_ShowMenu = value
    end Property
    Public Property Get ShowMenu()
        ShowMenu = M_ShowMenu
    End Property

    Public Property Let ImgPath(ByVal value)
        M_ImgPath = value
    end Property
    Public Property Let Image(ByVal value)
        M_Image = value
    end Property
    Public Property Get Image()
        Image = M_Image
    End Property
    
    public Property Get TxtConfig()
        TxtConfig = "text="& M_Text & ";"
        if M_ShowMenu <> "" then
            TxtConfig = TxtConfig & "showmenu="& M_ShowMenu & ";"
        else
            TxtConfig = TxtConfig & "url="& M_Url & ";"
        end if
        TxtConfig = TxtConfig & "status="& M_Status & ";"
        if M_Image <> "" then TxtConfig = TxtConfig & "image="& M_ImgPath & M_Image & ";"
    end Property
end class

class MenuStyle
    public Name
    public OnBgColor
    public OnColor
    public OffBgColor
    public OffColor
    public BorderColor
    public BorderStyle
    public BorderWidth
    public SeparatorColor
    public SeparatorSize
    public Padding
    public FontSize
    public FontStyle
    public FontWeight
    public FontFamily
    public SubimagePadding
    public OnBorder
    public OffBorder
    public SeparatorPadding
    public SeparatorAlign
    public SeparatorWidth
    public OverFilter
    public OutFilter
    public ItemWidth
    public Image
    public SubImage
    public MenuBgImage
end class

class Menu
    private M_menuCloseDelay
    private M_menuOpenDelay
    private M_subOffsetTop
    private M_subOffsetLeft
    private M_ImgPath
    private M_SourcePath
    private M_StyleMenu
    private M_Conn
    public HM_NovaPagina
    public OidFuncionario
    
    private CollectionStyle()
    private CollectionItemMenu()

    private sub Class_Initialize()
        OidFuncionario = 0
        M_SourcePath = ""
        M_ImgPath = ""
        redim CollectionStyle(0)
        redim CollectionItemMenu(0)

        set M_Conn = Server.CreateObject("ADODB.Connection")
        M_Conn.ConnectionString = Application("dataconn_ConnectionString")
        M_Conn.CommandTimeout = Application("dataconn_CommandTimeout")
        M_Conn.ConnectionTimeout = Application("dataconn_ConnectionTimeout")
        M_Conn.Open
    end sub
    private sub Class_Terminate()
        set M_StyleMenu = nothing
        M_Conn.Close
        set M_Conn = nothing
    end sub

    Public Property Get Style(byval Index)
        if Index > 0 and Index <= UBound(CollectionStyle) then
            set Style = CollectionStyle(Index)
        elseif Index = NextStyle then
            redim preserve CollectionStyle(Index)
            set CollectionStyle(Index) = new MenuStyle
            set Style = CollectionStyle(Index)
        end if
    End Property
    public property get NextStyle
        NextStyle = UBound(CollectionStyle) + 1
    end property
    
    Public Property Get MenuItem(byval Index)
        if Index > 0 and Index <= UBound(CollectionItemMenu) then
            set MenuItem = CollectionItemMenu(Index)
        elseif Index = NextMenuItem then
            redim preserve CollectionItemMenu(Index)
            set CollectionItemMenu(Index) = new ItemMenu
            CollectionItemMenu(Index).ImgPath = M_ImgPath
            set MenuItem = CollectionItemMenu(Index)
        end if
    End Property
    public property get NextMenuItem
        NextMenuItem = UBound(CollectionItemMenu) + 1
    end property
    Public Property Get MenuByName(byval Nome)
        dim i
        for i = 1 to UBound(CollectionItemMenu)
            if CollectionItemMenu(i).Name = Nome then
                set MenuByName = CollectionItemMenu(i)
                exit for
            end if
        next
    End Property

    Public Property Let menuCloseDelay(ByVal value)
        M_menuCloseDelay = value
    end Property
    Public Property Let menuOpenDelay(ByVal value)
        M_menuOpenDelay = value
    end Property
    Public Property Let subOffsetTop(ByVal value)
        M_subOffsetTop = value
    end Property
    Public Property Let subOffsetLeft(ByVal value)
        M_subOffsetLeft = value
    end Property
    Public Property Let ImgPath(ByVal value)
        M_ImgPath = value
    end Property
    Public Property Let SourcePath(ByVal value)
        M_SourcePath = value
    end Property
    
    public sub MontarMenu
        dim i, j
        Response.Write "<SCRIPT language=JavaScript src="""& M_SourcePath & "milonic_src.js"" type=text/javascript></SCRIPT>"& VbCrLf
        Response.Write "<SCRIPT	language=JavaScript src="""& M_SourcePath & "mmenudom.js""></script>"& VbCrLf
        Response.Write "<SCRIPT language=JavaScript>"& VbCrLf

        'Necessrio nos sistemas da MU
        Response.Write "var HM_NovaPagina = """& HM_NovaPagina &""";"& VbCrLf

        Response.Write "_menuCloseDelay = "& M_menuCloseDelay &";"& VbCrLf 'The time delay for menus to remain visible on mouse out
        Response.Write "_menuOpenDelay = "& M_menuOpenDelay &";"& VbCrLf   'The time delay before menus open on mouse over
        Response.Write "_subOffsetTop = "& M_subOffsetTop &";"& VbCrLf     'Sub menu top offset
        Response.Write "_subOffsetLeft = "& M_subOffsetLeft &";"& VbCrLf   'Sub menu left offset

        'Define os estilos de menu
        for i = 1 to Ubound(CollectionStyle)
            Response.Write "var "& CollectionStyle(i).Name & " = new mm_style();"& VbCrLf
            if CollectionStyle(i).OnBgColor <> "" then        Response.Write CollectionStyle(i).Name & ".onbgcolor="""& CollectionStyle(i).OnBgColor &""";"& VbCrLf
            if CollectionStyle(i).OnColor <> "" then          Response.Write CollectionStyle(i).Name & ".oncolor="""& CollectionStyle(i).OnColor &""";"& VbCrLf
            if CollectionStyle(i).OffBgColor <> "" then       Response.Write CollectionStyle(i).Name & ".offbgcolor="""& CollectionStyle(i).OffBgColor &""";"& VbCrLf
            if CollectionStyle(i).OffColor <> "" then         Response.Write CollectionStyle(i).Name & ".offcolor="""& CollectionStyle(i).OffColor &""";"& VbCrLf
            if CollectionStyle(i).BorderColor <> "" then      Response.Write CollectionStyle(i).Name & ".bordercolor="""& CollectionStyle(i).BorderColor &""";"& VbCrLf
            if CollectionStyle(i).BorderStyle <> "" then      Response.Write CollectionStyle(i).Name & ".borderstyle="""& CollectionStyle(i).BorderStyle &""";"& VbCrLf
            if CollectionStyle(i).BorderWidth <> "" then      Response.Write CollectionStyle(i).Name & ".borderwidth="& CollectionStyle(i).BorderWidth &";"& VbCrLf
            if CollectionStyle(i).SeparatorColor <> "" then   Response.Write CollectionStyle(i).Name & ".separatorcolor="""& CollectionStyle(i).SeparatorColor &""";"& VbCrLf
            if CollectionStyle(i).SeparatorSize <> "" then    Response.Write CollectionStyle(i).Name & ".separatorsize="""& CollectionStyle(i).SeparatorSize &""";"& VbCrLf
            if CollectionStyle(i).Padding <> "" then          Response.Write CollectionStyle(i).Name & ".padding="& CollectionStyle(i).Padding &";"& VbCrLf
            if CollectionStyle(i).FontSize <> "" then         Response.Write CollectionStyle(i).Name & ".fontsize="""& CollectionStyle(i).FontSize &""";"& VbCrLf
            if CollectionStyle(i).FontStyle <> "" then        Response.Write CollectionStyle(i).Name & ".fontstyle="""& CollectionStyle(i).FontStyle &""";"& VbCrLf
            if CollectionStyle(i).FontWeight <> "" then       Response.Write CollectionStyle(i).Name & ".fontweight="""& CollectionStyle(i).FontWeight &""";"& VbCrLf
            if CollectionStyle(i).FontFamily <> "" then       Response.Write CollectionStyle(i).Name & ".fontfamily="""& CollectionStyle(i).FontFamily &""";"& VbCrLf
            if CollectionStyle(i).SubimagePadding <> "" then  Response.Write CollectionStyle(i).Name & ".subimagepadding="""& CollectionStyle(i).SubimagePadding &""";"& VbCrLf
            if CollectionStyle(i).OnBorder <> "" then         Response.Write CollectionStyle(i).Name & ".onborder="""& CollectionStyle(i).OnBorder &""";"& VbCrLf
            if CollectionStyle(i).OffBorder <> "" then        Response.Write CollectionStyle(i).Name & ".offborder="""& CollectionStyle(i).OffBorder &""";"& VbCrLf
            if CollectionStyle(i).SeparatorPadding <> "" then Response.Write CollectionStyle(i).Name & ".separatorpadding="""& CollectionStyle(i).SeparatorPadding &""";"& VbCrLf
            if CollectionStyle(i).SeparatorAlign <> "" then   Response.Write CollectionStyle(i).Name & ".separatoralign="""& CollectionStyle(i).SeparatorAlign &""";"& VbCrLf
            if CollectionStyle(i).SeparatorWidth <> "" then   Response.Write CollectionStyle(i).Name & ".separatorwidth="""& CollectionStyle(i).SeparatorWidth &""";"& VbCrLf
            if CollectionStyle(i).Image <> "" then            Response.Write CollectionStyle(i).Name & ".image="""& M_ImgPath & CollectionStyle(i).Image &""";"& VbCrLf
            if CollectionStyle(i).SubImage <> "" then         Response.Write CollectionStyle(i).Name & ".subimage="""& M_ImgPath & CollectionStyle(i).SubImage &""";"& VbCrLf
            if CollectionStyle(i).OverFilter <> "" then       Response.Write CollectionStyle(i).Name & ".overfilter="""& CollectionStyle(i).OverFilter &""";"& VbCrLf
            if CollectionStyle(i).OutFilter <> "" then        Response.Write CollectionStyle(i).Name & ".outfilter="""& CollectionStyle(i).OutFilter &""";"& VbCrLf
            if CollectionStyle(i).ItemWidth <> "" then        Response.Write CollectionStyle(i).Name & ".itemwidth="""& CollectionStyle(i).ItemWidth &""";"& VbCrLf
            if CollectionStyle(i).MenuBgImage <> "" then      Response.Write CollectionStyle(i).Name & ".menubgimage="""& M_ImgPath & CollectionStyle(i).MenuBgImage &""";"& VbCrLf & VbCrLf
        next

        for i = 1 to Ubound(CollectionItemMenu)
            Response.Write "var myMenu = new menuname("""& CollectionItemMenu(i).Name &""");"& VbCrLf
            Response.Write "myMenu.style="& CollectionItemMenu(i).Style &";"& VbCrLf
            if CollectionItemMenu(i).Top <> "" then           Response.Write "myMenu.top="& CollectionItemMenu(i).Top &";"& VbCrLf
            if CollectionItemMenu(i).Left <> "" then          Response.Write "myMenu.left="& CollectionItemMenu(i).Left &";"& VbCrLf
            if CollectionItemMenu(i).AlwaysVisible <> "" then Response.Write "myMenu.alwaysvisible="& CollectionItemMenu(i).AlwaysVisible &";"& VbCrLf
            if CollectionItemMenu(i).Orientation <> "" then   Response.Write "myMenu.orientation='"& CollectionItemMenu(i).Orientation &"';"& VbCrLf
            if CollectionItemMenu(i).Margin <> "" then        Response.Write "myMenu.margin="& CollectionItemMenu(i).Margin &";"& VbCrLf
            if CollectionItemMenu(i).OverFlow <> "" then      Response.Write "myMenu.overflow='"& CollectionItemMenu(i).OverFlow &"';"& VbCrLf

            for j = 1 to CollectionItemMenu(i).NumAI
                Response.Write "myMenu.aI("""& CollectionItemMenu(i).AI(j).TxtConfig &""");"& VbCrLf
            next
            Response.Write VbCrLf
        next

        Response.Write "drawMenus();"& VbCrLf
        Response.Write "</SCRIPT>"& VbCrLf
    end sub
    
    public sub MontarMUMenu(byval REscopo, byval Style, byval Top, byval Left, byval AlwaysVisible, byval Orientation, byval Margin, byval OverFlow)
        dim i, rs, sql, vFilhos(), TemAcessoOpcao
        redim vFilhos(0)
        
        i = NextMenuItem
        MenuItem(i).Name = "Menu"& Rescopo
        MenuItem(i).style = Style
        if not isnull(Top) then MenuItem(i).top = Top
        if not isnull(Left) then MenuItem(i).left = Left
        if not isnull(AlwaysVisible) then MenuItem(i).alwaysvisible = AlwaysVisible
        if not isnull(Orientation) then MenuItem(i).orientation = Orientation
        if not isnull(Margin) then MenuItem(i).margin = Margin
        if not isnull(OverFlow) then MenuItem(i).OverFlow = OverFlow

        set rs = Server.CreateObject("ADODB.RecordSet")
        
        sql = "select id, Nome, Link, rListadeObjetos from mu_menu where rescopo = "& REscopo &" order by Ordem"
        rs.Open sql, M_Conn, 3, 1
        
        while not rs.EOF
            TemAcessoOpcao = true
            If OidFuncionario <> 0 And not IsNull(rs("rListadeObjetos")) Then
                TemAcessoOpcao = AcessoListaDeObjetos(rs("rListadeObjetos"))
            End If
            if TemAcessoOpcao then
                j = MenuItem(i).NextAI
                MenuItem(i).AI(j).Text = RS("Nome")
                if TemFilhos(RS("ID")) then
                    MenuItem(i).AI(j).ShowMenu = "Menu"& RS("ID")
                    redim preserve vFilhos(UBound(vFilhos)+1)
                    vFilhos(UBound(vFilhos)) = RS("ID")
                else
                    MenuItem(i).AI(j).Url = replace(RS("Link"), "window.open(", "openPage(")
                end if
            end if
            rs.MoveNext 
        wend
        rs.close
        set rs = nothing
        
        for i = 1 to Ubound(vFilhos)
            call MontarMUMenu(vFilhos(i), CollectionStyle(2).Name, null, null, null, null, 0, null)
        next
    end sub
    
    private function TemFilhos(byval id)
        dim rs, sql
        set rs = Server.CreateObject("ADODB.RecordSet")
        
        sql = "select count(1) num from mu_menu where rescopo = "& id
        rs.Open sql, M_Conn, 3, 1
        
        TemFilhos = (rs("num") > 0)
    end function
	 
    private function AcessoListaDeObjetos(byval rListadeObjetos)
        Dim rs5, rs6, OIDComunicFunc, LastSQL

        set rs5 = Server.CreateObject("ADODB.RecordSet")
        set rs6 = Server.CreateObject("ADODB.RecordSet")
        
        AcessoListaDeObjetos = true
        
        'Verifica se o item enviado  um oid de usurio vlido
        LastSQL = "SELECT oid FROM usuario WHERE oid=" & OidFuncionario
        rs5.Open LastSQL, M_Conn, 3, 1
        If rs5.EOF Then
            'O item enviado no  um usurio, verifica se  um funcionrio
            rs5.Close
            
            LastSQL = "SELECT rendereco FROM comunicacao WHERE rtipo=1121 AND ritem=" & OidFuncionario
            rs5.Open LastSQL, M_Conn, 3, 1
            If rs5.EOF Then
                'O item enviado no  nem um usurio, nem um funcionrio
                AcessoListaDeObjetos = false
                rs5.Close
                set rs6 = nothing
                set rs5 = nothing
                Exit Function
            Else
                OIDComunicFunc = rs5("rendereco")
            End If
        Else
            OIDComunicFunc = OidFuncionario
        End If
        rs5.Close
        
        '*****************************************************************
        ' Seleciona em ordem para checar a permisso do usurio
        ' primeiro o oid dele, depois do seu agrupamento e depois do oid=1
        '*****************************************************************
        LastSQL = "select item.oid, 1 from item where oid=" & OIDComunicFunc & _
           " Union select item.oid, 2 from item inner join agrupamento on item.oid=agrupamento.rgrupo and agrupamento.ritem=" & OIDComunicFunc & _
           " Union select item.oid, 3 from item where oid = 1 order by 2"
        rs5.Open LastSQL, M_Conn, 3, 1
        While Not rs5.EOF
            LastSQL = "select rescopo, Acesso from permissao where rusuario = " & rs5("oid") & " and rescopo=" & rListadeObjetos
            rs6.Open LastSQL, M_Conn, 3, 1
            '**********************************************************************
            ' Caso no ache nenhum registro falando da permisso da opo, esta
            ' obedece o padro
            ' Caso tenha analisa se o usurio no tem permisso (0)
            ' ou tem (<>0)
            '**********************************************************************
            If Not rs6.EOF Then
                If rs6("Acesso") = 0 Then
                    AcessoListaDeObjetos = false
                Else
                    AcessoListaDeObjetos = true
                End If
                rs6.Close
                rs5.Close
                set rs6 = nothing
                set rs5 = nothing
                exit function
            End If
            rs6.Close
            rs5.MoveNext
        Wend
        
        rs5.Close
        Set rs5 = Nothing
        Set rs6 = Nothing
    end function
end class
%>