/*
	Desenvolvido por Daniel Augusto Nunes | daniel@microuniverso.com.br
	Verso 2.0 | Abril, 2002
	
	ltima atualizao: 26/03/2003

	CABEALHO DAS FUNES:
	----------------------
	
	1) CheckTxt(txtField[,type[,Msg]]);
			Valida campos do tipo <input type=text> onde
			- txtField:  Campo texto do formulrio que se deseja validar
			- type: Opcional; Tipo de validao a fazer ('*','E-mail','Data','Nmero','IP','CPF')
			- Msg: Opcional; Mensagem de erro a ser exibida caso um erro ocorra
		Obs.:
			1) Para apenas forar a entrada de valor, informando a Msg de erro, use '*' no parmetro type
	
	-- x --
	
	2) CheckSelect(objSel[,Msg]);
			Verifica se o valor escolhido  diferente do primeiro em campos do tipo <select> onde
			- objSel: Campo select que se deseja validar
			- Msg: Opcional; Mensagem de erro a ser exibida caso um erro ocorra
	
	-- x --
	
	3) CheckSelectM(objSel,Max[,Msg]);
			Valida campos do tipo <select multiple> onde
			- objSel: Campo select que se deseja validar.
			- Max: Nmero mximo de opes que o usurio pode escolher.
			- Msg: Opcional; Mensagem de erro a ser exibida caso um erro ocorra.
		Obs.:
			1) Para permitir selecionar todas as opes, use form.selField.length em Max.
			
	-- x --
	
	4) CheckCBOX_RADIO(objToCheck[,Msg]);
			Valida campos do tipo <input tape=checkbox> ou <input tape=radio> onde
			- objToCheck: Campo checkbox ou radio que se deseja validar.
			- Msg: Opcional; Mensagem de erro a ser exibida caso um erro ocorra.
		Obs.:
			1) Funciona tanto para um nico checkbox|radio quanto para uma coleo deles (mesma propridade name).
			
	-- x --
	Considerao: Caso no seja informada uma mensagem de erro, para todas as rotinas,
		o nome do campo passa a ser a mensagem de erro (no aconselho o seu uso).
		
	-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
	
	COMO USAR O SCRIPT CODVALIDA.JS:
	--------------------------------
	1) No cabealho da pgina a ser validada, insira a linha:
		<SCRIPT LANGUAGE=JavaScript src="codValida.js"></SCRIPT>
		
	2) Crie uma funo para a validao, ela recebe um <form> como parmetro de entrada.
		Para cada campo do seu form que deseja validar, insira a chamada da funo adequada para ele, como segue. No
		exemplo, tenho um formulrio com os campos de nome (tag NAME) txtIP, txtNome, rbSexo, selEstado, selInteresses, 
		cbCarro, rbConcordo, rbConcordo. Cdigo a ser inserido para que eles sejam validados:
		
		<SCRIPT LANGUAGE=JavaScript>
		<!--
			function CheckForm(form){
				if (!CheckTxt(form.txtIP,'IP','Preencha um ENDEREO IP vlido!'))
					return false;
				if (!CheckTxt(form.txtNome,'*','Digite um NOME!'))
					return false;
				if (!CheckCBOX_RADIO(form.rbSexo,'Informe o SEXO!'))
					return false;
				if (!CheckSelect(form.selEstado,'Selecione o ESTADO!'))
					return false;
				if (!CheckSelectM(form.selInteresses,3,'Selecione pelo menos uma opo!'))
					return false;
				if (!CheckCBOX_RADIO(form.cbCarro,'Marque a opo adequada!'))
					return false;
				if (!CheckCBOX_RADIO(form.rbConcordo,'Concorda com os termos?'))
					return false;
				if (!CheckCBOX_RADIO(form.cbSemDuvida,'Tem dvidas quanto aos termos?'))
					return false;
				
				// Todos os campos foram validados corretamente
				return true;
			}
		//-->
		</SCRIPT>
		
	3) Sua TAG <form> deve ter o seguinte comando: OnSubmit="return CheckForm(this);".
		A seguir temos a TAG <form> para o exemplo acima:
			<FORM id=FORM1 name=FORM1 action="" method=post OnSubmit="return CheckForm(this);">

*/

function CheckTxt(txtField,type,Msg){
	
	var NumDig = 4; // Nmero de dgitos do ano no caso de uma validao de data.
	if(!Msg)
		Msg = txtField.name;
	
	if(txtField.value == '') {
		alert(Msg);
		if(txtField.type != 'hidden')
			txtField.focus();
		return false;
	}
	
	// Validao  de data, configurar o nmero de dgitos aceitos no ano.
	if (type == 'Data_2'){
		NumDig = 2;
		type = 'Data';
	}
	else
		if (type == 'Data_4')
		{
			NumDig = 4;
			type = 'Data';
		}
		
	switch (type) {
		case 'E-mail' :
			if(txtField.value.indexOf('@') == -1 || txtField.value.indexOf('.') == -1){
				alert('Digite um endereo de e-mail vlido!');
				if(txtField.type != 'hidden')
					txtField.focus();
				return false;
			}
			break;
			
		case 'Data':
			with(txtField.value){
				if (NumDig == 4){					
					// Verifica se a entrada do usurio est no formato DD/MM/AAAA
					if (charAt(2) != '/' || charAt(5) != '/' || length != 10){
						alert('Formato de data invlido!\nFormato correto: DD/MM/AAAA!');
						if(txtField.type != 'hidden')
							txtField.focus();
						return false;
					}
				}
				else{		
					// Verifica se a entrada do usurio est no formato DD/MM/AA
					if (charAt(2) != '/' || charAt(5) != '/' || length != 8){
						alert('Formato de data invlido!\nFormato correto: DD/MM/AA!');
						if(txtField.type != 'hidden')
							txtField.focus();
						return false;
					}
				}
				
				// Verifica se o dia, ms e ano so nmeros e se todos so vlidos.
				var Dia,Mes,Ano;
				if (charCodeAt(0) == 48)
					Dia = parseInt(substring(1,2));
				else
					Dia = parseInt(substring(0,2));
					
				if (charCodeAt(3) == 48)
					Mes = parseInt(substring(4,5));
				else
					Mes = parseInt(substring(3,5));
					
				Ano = parseInt(substring(6,length));
				
				if (Dia < 1 || Dia > 31 || isNaN(Dia)){ // Dia no  vlido.
					alert('DIA INVLIDO!\nData Informada: '+txtField.value);
					if(txtField.type != 'hidden')
						txtField.focus();
					return false;
				}
				if (Mes < 1 || Mes > 12 || isNaN(Mes)){ // Ms no  vlido.
					alert('MS INVLIDO!\nData Informada: '+txtField.value);
					if(txtField.type != 'hidden')
						txtField.focus();
					return false;
				}
				if ((NumDig == 4 && Ano < 1900) || isNaN(Ano)){ // Ano no  vlido
					alert('ANO INVLIDO!\nO ano deve ser maior que 1900!\nData Informada: '+txtField.value);
					//alert('Erro:\nO ano deve ser maior que 1900!');
					if(txtField.type != 'hidden')
						txtField.focus();
					return false;
				}
				/*
					Entra aqui uma rotina para calcular se o ano  bissexto.
					Com isso, valido o nmero de dias para o ms de fevereiro.
				*/
				var AnoBiss = 0;
				if ((Ano%4 == 0 && Ano%100 != 0) || Ano%400 == 0)
					AnoBiss = 1;
				else
					AnoBiss = 0;
				if ((Mes == 2 && AnoBiss == 1 && Dia > 29) || (Mes == 2 && AnoBiss == 0 && Dia > 28)){
					alert('A data digitada  invlida!');
					if(txtField.type != 'hidden')
						txtField.focus();
					return false;
				}
				// Verifica o nmero de dias para os meses que tm apenas 30 dias:
				if ((Mes == 4 || Mes == 6 || Mes == 9 || Mes == 11) && Dia > 30){
					alert('A data digitada  invlida!');
					if(txtField.type != 'hidden')
						txtField.focus();
					return false;
				}
			}
			break;
		case 'Nmero' :
			if(isNaN(parseInt(txtField.value))){
				alert('Digite um nmero inteiro para o campo '+Msg+'!');
				if(txtField.type != 'hidden')
					txtField.focus();
				return false;
				/*
				Para testar se o nmero  real:
				if(isNaN(parseFloat(txtField.value))){
				alert('Digite um nmero real para este campo!');
				*/
			}
			break;
			
		case 'CPF' :
			if(!CheckCPF(txtField.value)){
				alert('CPF invlido!');
				if(txtField.type != 'hidden')
					txtField.focus();
				return false;
			}
			break;
		case 'IP' :
			var sErro = "";
			var theName = "Endereo IP";

			var ipPattern = /^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/;
			var ipArray = txtField.value.match(ipPattern); 

			if (txtField.value == "0.0.0.0" || txtField.value == "255.255.255.255")
				sErro = sErro + theName + ': '+txtField.value+'  um endereo de ip especial e no pode ser usado.';
					
			if (ipArray == null)
				sErro = sErro + theName + ': '+txtField.value+' no  um endereo de ip vlido.';
			else {
				for (i=0; i<4; i++) {
					thisSegment = ipArray[i];
					if (thisSegment > 255) {
						sErro = sErro + theName + ': '+txtField.value+' no  um endereo de ip vlido.';
						i = 4;
					}
					if ((i == 0) && (thisSegment > 255)) {
						sErro = sErro + theName + ': '+txtField.value+'  um endereo de ip especial e no pode ser usado.';
						i = 4;
			      }
			   }
			}
			
			if (sErro != "") {
				alert (sErro);
				if(txtField.type != 'hidden')
					txtField.focus();
				return false;
			}
			break;
		default:
			;
	}
	return true;
}
function CheckSelect(objSel,Msg){
	if(!Msg)
		Msg = objSel.name;
		
	if (objSel.selectedIndex == 0 || objSel.value == ''){ // O valor aqui deve ser 0, pois o navegador j seleciona o primeiro tem por default.
		alert(Msg);
		objSel.focus();
		return false;
	}
	
	return true;
	
}
function CheckSelectM(objSel,Max,Msg){
	
	var nSel = 0;
	
	if(!Msg)
		Msg = objSel.name;
		
	if (objSel.selectedIndex == -1){
		alert(Msg);
		objSel.focus();
		return false;
	}

	if (Max != -1){
		for(var i=0;i<objSel.length;i++)
			if (objSel.options[i].selected)
				nSel++;
	
		if (nSel > Max) {
			if (Max == 1)
				alert('Voc deve selecionar no mximo ' + Max + ' opo!');
			else
				alert('Voc deve selecionar no mximo ' + Max + ' opes!');
			objSel.focus();
			return false;	
		}
	}
	
	return true;
}

// Valida CHECKBOX ou um grupo deles | RADIO BUTTON ou um grupo deles
function CheckCBOX_RADIO(objToCheck,Msg){
	
	var nSel=0;	/* Nmero de CHECKBOXES ou RADIO BUTTONS selecionadas */
	
	if(!Msg)
		Msg = objToCheck.name;
	
	// Quando s existe um CHECKBOX | RADIO BUTTON na pgina, ele no aceita ser tratado como uma coleo
	
	if (!objToCheck.length){
		if (objToCheck.checked)
			nSel++;
	}
	else{
		for(var i=0;i<objToCheck.length;i++)
			if(objToCheck[i].checked)
				nSel++;
	}
	
	// Um ou mais check boxes ou radio buttons foram selecionados?
	
	if(nSel == 0){
		alert(Msg);
		if (!objToCheck.length)
			objToCheck.focus();
		else
			objToCheck[0].focus();
		return false;
	}
	
	return true;
}
function CheckDiff(txtMenor,txtMaior,type,Msg){
	
	if(!Msg)
		Msg = "INTERVALO INVLIDO!";
	
	switch(type){
		case 'int':
			if (parseInt(txtMenor.value) > parseInt(txtMaior.value)){
				alert(Msg);
				if (txtMenor.type != 'hidden')
					txtMenor.focus();
				return false;
			}
			break;
			
		case 'float':
			if (parseFloat(txtMenor.value) > parseFloat(txtMaior.value)){
				alert(Msg);
				if (txtMenor.type != 'hidden')
					txtMenor.focus();
				return false;
			}
			break;
			
		case 'data':
			if (CheckTxt(txtMenor,'Data_4',' necessria uma data inicial!') && CheckTxt(txtMaior,'Data_4',' necessria uma data final!')){
				var DiaINI,DiaFIM,MesINI,MesFIM,AnoINI,AnoFIM;
				with(txtMenor.value){
					if (charCodeAt(0) == 48)
						DiaINI = parseInt(substring(1,2));
					else
						DiaINI = parseInt(substring(0,2));
						
					if (charCodeAt(3) == 48)
						MesINI = parseInt(substring(4,5));
					else
						MesINI = parseInt(substring(3,5));
						
					AnoINI = parseInt(substring(6,length));
				}
				with(txtMaior.value){
					if (charCodeAt(0) == 48)
						DiaFIM = parseInt(substring(1,2));
					else
						DiaFIM = parseInt(substring(0,2));
						
					if (charCodeAt(3) == 48)
						MesFIM = parseInt(substring(4,5));
					else
						MesFIM = parseInt(substring(3,5));
						
					AnoFIM = parseInt(substring(6,length));
				}
				if (AnoFIM < AnoINI){ /* ANO DA LTIMA DATA  MENOR QUE O ANO DA  PRIMEIRA */
					alert(Msg);
					if (txtMenor.type != 'hidden')
						txtMenor.focus();
					return false;
				}
				else{
					if(AnoFIM == AnoINI){
						if (MesFIM < MesINI){ /* ANOS IGUAIS, MAS MS DA LTIMA DATA  MENOR QUE O MS DA PRIMEIRA */
							alert(Msg);
							if (txtMenor.type != 'hidden')
								txtMenor.focus();
							return false;
						}
						else{
							if (MesFIM == MesINI){
								if (DiaFIM < DiaINI){ /* ANOS E MSES IGUAIS, MAS DIA DA LTIMA DATA  MENOR QUE O DIA DA PRIMEIRA */
									alert(Msg);
									if (txtMenor.type != 'hidden')
										txtMenor.focus();
									return false;
								}
							}
						}
					}
				}
			}
			else
				return false;
			break;
			
		case 'str':
			if (txtMenor.value.toString() > txtMaior.value.toString()){
				alert(Msg);
				if (txtMenor.type != 'hidden')
					txtMenor.focus();
				return false;
			}
			break;
		
		default:
			;
	}

	return true;
}

function CheckCPF (CPF) {
 
	if (CPF.length != 11 || CPF == "00000000000" || CPF == "11111111111" || CPF == "22222222222" || CPF == "33333333333" || CPF == "44444444444" || CPF == "55555555555" || CPF == "66666666666" || CPF == "77777777777" || CPF == "88888888888" || CPF == "99999999999")
		return false;
 
	soma = 0;
	for (i=0; i<9; i++)
		soma += parseInt(CPF.charAt(i)) * (10 - i);
	
	resto = 11 - (soma % 11);
	if (resto == 10 || resto == 11)
		resto = 0;
 
	if (resto != parseInt(CPF.charAt(9)))
		return false;
 
	soma = 0;
	for (i = 0; i < 10; i ++)
		soma += parseInt(CPF.charAt(i)) * (11 - i);
 
	resto = 11 - (soma % 11);
	if (resto == 10 || resto == 11)
		resto = 0;
 
	if (resto != parseInt(CPF.charAt(10)))
		return false;

	return true;
}